"use strict";
function action(parameters) {
    if (parameters === void 0) { parameters = null; }
    return function (target, propertyKey, descriptor) {
        if (target.constructor.prototype.decorate == null) {
            target.constructor.prototype.decorate = {};
        }
        if (!target.decorate['routes']) {
            target.decorate['routes'] = {};
        }
        if (!target.decorate['routes'][propertyKey]) {
            target.decorate['routes'][propertyKey] = {};
        }
        if (parameters) {
            for (var param in parameters) {
                target.decorate['routes'][propertyKey][param] = parameters[param];
            }
        }
        return descriptor;
    };
}
exports.action = action;
//# sourceMappingURL=ActionDecorator.js.map