"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ContentResult_1 = require("../View/ContentResult");
var DownloadResult_1 = require("../View/DownloadResult");
var FileResult_1 = require("../View/FileResult");
var JsonResult_1 = require("../View/JsonResult");
var RedirectResult_1 = require("../View/RedirectResult");
var ViewResult_1 = require("../View/ViewResult");
var Controller_1 = require("./Controller");
var HttpController = (function (_super) {
    __extends(HttpController, _super);
    function HttpController() {
        _super.apply(this, arguments);
    }
    HttpController.prototype.__setRequest = function (request) {
        this.request = request;
    };
    HttpController.prototype.__setResponse = function (response) {
        this.response = response;
    };
    HttpController.prototype.__setSend = function (send) {
        this.send = send;
    };
    HttpController.prototype.redirect = function (url, status) {
        if (status === void 0) { status = 302; }
        this.send(new RedirectResult_1.RedirectResult(url, status));
    };
    HttpController.prototype.content = function (text, contentType) {
        this.send(new ContentResult_1.ContentResult(text, contentType));
    };
    HttpController.prototype.json = function (data) {
        this.send(new JsonResult_1.JsonResult(data));
    };
    HttpController.prototype.file = function (path) {
        this.send(new FileResult_1.FileResult(path));
    };
    HttpController.prototype.download = function (path, filename) {
        this.send(new DownloadResult_1.DownloadResult(path, filename));
    };
    HttpController.prototype.view = function (template, options) {
        var result = new ViewResult_1.ViewResult(template);
        if (options)
            result.options = options;
        this.send(result);
    };
    return HttpController;
}(Controller_1.Controller));
exports.HttpController = HttpController;
//# sourceMappingURL=HttpController.js.map