"use strict";
var huject_1 = require('huject');
var AutoLoader_1 = require("./AutoLoader");
var Debug_1 = require("./Debug");
var Application = (function () {
    function Application(rootDirectory, serviceProviders) {
        var _this = this;
        this.rootDirectory = rootDirectory;
        this.serviceProviders = serviceProviders;
        this.container = new huject_1.Container();
        this.printHeader();
        this.container = new huject_1.Container();
        this.loader = new AutoLoader_1.AutoLoader(this, this.container);
        serviceProviders.forEach(function (serviceProvider) {
            _this.loader.addServiceProvider(serviceProvider);
        });
        this.loader.load();
        this.loader.boot();
    }
    Application.getEnvironment = function () {
        return ((process.env.NODE_ENV == null) ? 'dev' : process.env.NODE_ENV);
    };
    Application.getVersion = function () {
        return require('root-require')('package.json').version;
    };
    Application.getRepositoryAddress = function () {
        var repo = require('root-require')('package.json').repository.url;
        repo = repo.replace("git://", "https://");
        repo = repo.replace(".git", "");
        return String(repo);
    };
    Application.prototype.start = function () {
        this.loader.start();
        Debug_1.__INFO("Application fully started");
    };
    Application.prototype.printHeader = function () {
        console.log("-----------------------------------------------------------------------------         ");
        console.log("   ___________       ______                                             __            ");
        console.log("  /_  __/ ___/      / ____/________ _____ ___  ___ _      ______  _____/ /__          ");
        console.log("   / /  \\__ \\______/ /_  / ___/ __ `/ __ `__ \\/ _ \\ | /| / / __ \\/ ___/ //_/     ");
        console.log("  / /  ___/ /_____/ __/ / /  / /_/ / / / / / /  __/ |/ |/ / /_/ / /  / ,<             ");
        console.log(" /_/  /____/     /_/   /_/   \\__,_/_/ /_/ /_/\\___/|__/|__/\\____/_/  /_/|_|         ");
        console.log("                                                                                      ");
        console.log(" GitHub:  %s                                      ", Application.getRepositoryAddress());
        console.log(" Version: %s                                                ", Application.getVersion());
        console.log(" Config:  %s                                            ", Application.getEnvironment());
        console.log("-----------------------------------------------------------------------------         ");
    };
    return Application;
}());
exports.Application = Application;
//# sourceMappingURL=Application.js.map