"use strict";
var _ = require("lodash");
var Configuration = (function () {
    function Configuration() {
        this.data = {};
    }
    Configuration.prototype.get = function (key) {
        var keyParts = key.split('.');
        return _.reduce(keyParts, function (data, key) { return !!data ? data[key] : undefined; }, this.data);
    };
    Configuration.prototype.set = function (key, value) {
        var keyParts = key.split('.');
        var data = this.data;
        _.forEach(keyParts, function (key) {
            if (key == _.last(keyParts)) {
                data[key] = value;
            }
            else {
                data[key] = typeof data[key] == 'object' ? data[key] : {};
            }
            data = data[key];
        });
    };
    return Configuration;
}());
exports.Configuration = Configuration;
//# sourceMappingURL=Configuration.js.map