/// <reference path="../../../../typings/main.d.ts" />
import * as Express from "express";
import { ICookieOption } from "../Core/Cookie";
export declare class Response {
    private rawResponse;
    constructor(rawResponse: Express.Response);
    setStatus(code: number): Response;
    getStatus(): number;
    setHeader(field: string, value: string): Response;
    getHeader(field: string): string;
    setCookie(name: string, value: string, options?: ICookieOption): Response;
    removeCookie(name: string, path?: string): Response;
    setContentType(value: string): Response;
    setLinks(links: {}): Response;
    setLocal(name: string, value: any): Response;
    getLocal(name: string): any;
    sendContent(content: string): Response;
    sendJson(content: any): Response;
    sendFile(path: string): Response;
    sendDownload(path: string, name?: string): Response;
    sendView(view: string, options?: Object): Response;
    redirect(url: string, status?: number): Response;
    getRawResponse(): Express.Response;
}
