"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Debug_1 = require("../../Core/Debug");
var HttpServer_1 = require("../HttpServer");
var Route_1 = require("./Route");
var Request_1 = require("../Request");
var Response_1 = require("../Response");
var huject_1 = require('huject');
var Router = (function () {
    function Router() {
        this.routes = {};
    }
    Router.prototype.registerRoute = function (methods, path, action) {
        var route = new Route_1.Route();
        route.methods = methods;
        route.path = path;
        route.action = action;
        this.routes[path] = route;
        this.attachRouteToServer(route);
        Debug_1.__DEBUG("Registered route: " + methods + " " + path + " to " + action);
    };
    Router.prototype.attachRouteToServer = function (route) {
        var _this = this;
        route.methods.forEach(function (method) {
            var express = _this.httpServer.getExpress();
            express[method.toLowerCase()](route.path, _this.dispatch(route));
        });
    };
    Router.prototype.dispatch = function (route) {
        var container = this.container;
        return function (req, res, next) {
            res.header("X-Powered-By", "TS-Framework");
            var controller = container.resolve(route.getController());
            var request = new Request_1.Request(req);
            var response = new Response_1.Response(res);
            controller.__setRequest(request);
            controller.__setResponse(response);
            var send = function (result) {
                if (result !== undefined &&
                    result.__proto__.hasOwnProperty("execute") &&
                    result.execute instanceof Function) {
                    result.execute(response);
                }
                else {
                    res.end();
                }
                Debug_1.__DEBUG("[" + req.ip + "] (" + (req.statusCode || 200) + ") " + req.method + " " + req.path);
            };
            controller.__setSend(send);
            controller[route.getMethod()]();
        };
    };
    __decorate([
        huject_1.Inject("HttpServer"), 
        __metadata('design:type', HttpServer_1.HttpServer)
    ], Router.prototype, "httpServer", void 0);
    __decorate([
        huject_1.Inject("Container"), 
        __metadata('design:type', huject_1.Container)
    ], Router.prototype, "container", void 0);
    return Router;
}());
exports.Router = Router;
//# sourceMappingURL=Router.js.map