import { IDatabaseDriver, IDatabaseDriverEnd, IDatabaseDriverUnique, IDatabaseDriverRaw } from "./DatabaseDriver";
import { IModelValidation } from "./IModelValidation";
import { INoResultCallback } from "./INoResultCallback";
import { ISingleResultCallback } from "./ISingleResultCallback";
export interface IModel {
    save<T>(model: T, callback: ISingleResultCallback<T>): any;
    destroy<T>(model: T, callback: INoResultCallback<T>): any;
    all<T>(): IDatabaseDriverEnd<T>;
    where(query: {}): any;
    get(id: number): IDatabaseDriverUnique<any>;
    first<T>(id: number): IDatabaseDriverUnique<T>;
    find<T>(): IDatabaseDriver<T>;
    query<T>(id: number): IDatabaseDriverRaw<T>;
    validate(attr: string, options: IModelValidation): any;
    validate(attrs: string[], definition: IModelValidation): any;
    validate(obj: any, definition: IModelValidation): any;
}
